// $Id: kapp.cpp,v 1.17 1997/08/07 08:50:35 ettrich Exp $
//
// $Log: kapp.cpp,v $
// Revision 1.17  1997/08/07 08:50:35  ettrich
// Matthias: replaced $KDEDIR with kdedir() in the searchpath
//
// Revision 1.16  1997/07/27 13:43:57  kalle
// Even more SGI and SCC patches, security patch for kapp, various fixes for ksock
//
// Revision 1.15  1997/07/25 19:46:41  kalle
// SGI changes
//
// Revision 1.14  1997/07/24 21:04:38  kalle
// Kalle: Patches for SGI
//
// Revision 1.13  1997/06/29 18:26:35  kalle
// 29.06.97:	KConfig reads and writes string lists
// 			Torben's patches to ktoolbar.*, kurl.h
//
// 22.06.97:	KApplications save and restore position and size of their top
// (unstable)	level widget.
//
// Revision 1.12  1997/05/30 20:04:37  kalle
// Kalle:
// 30.05.97:	signal handler for reaping zombie help processes reinstalls itself
// 		patch to KIconLoader by Christian Esken
// 		slightly better look for KTabCtl
// 		kdecore Makefile does not expect current dir to be in path
// 		Better Alpha support
//
// Revision 1.11  1997/05/17 20:38:21  kalle
// Kalle:
// - Bugfix for KPanner (from Paul Kendall)
// - Better colors with kdisplay schemes (from Bernd Wuebben)
// - new behavior in KApplication::invokeHTMLHelp(): if the first
//   argument (the filename) is empty, the filename is defaulted to
// 	$KDEDIR/doc/HTML/<appname>/<appname>.html
// - KApplication::getCaption for Matthias added (breaks binary compatibility!)
//
// Revision 1.10  1997/05/15 20:33:19  wuebben
// Bernd: Added signals:
// kdisplayFontChanged()
// kdisplayPaletteChanged()
// kdisplayStyleChaned()
// Some applications such as kedit need to know when the Font, Palette,
// or Style ngeduy.
//
// Revision 1.9  1997/05/13 05:49:00  kalle
// Kalle: Default arguments for KConfig::read*Entry()
// app-specific config files don't start with a dot
// Bufgix for the bugfix in htmlobj.cpp (FontManager)
//
// Revision 1.8  1997/05/09 19:52:54  kalle
// Kalle: Application-specific config files without leading .
//
// Revision 1.7  1997/05/08 22:53:16  kalle
// Kalle:
// KPixmap gone for good
// Eliminated static objects from KApplication and HTML-Widget
//
// Revision 1.6  1997/05/02 16:46:34  kalle
// Kalle: You may now override how KApplication reacts to external changes
// KButton uses the widget default palette
// new kfontdialog version 0,5
// new kpanner by Paul Kendall
// new: KIconLoader
//
// Revision 1.5  1997/04/28 06:57:44  kalle
// Various widgets moved from apps to libs
// Added KSeparator
// Several bugs fixed
// Patches from Matthias Ettrich
// Made ksock.cpp more alpha-friendly
// Removed XPM-Loading from KPixmap
// Reaping zombie KDEHelp childs
// WidgetStyle of KApplication objects configurable via kdisplay
//
// Revision 1.4  1997/04/23 16:45:14  kulow
// fixed a bug in acinclude.m4 (Thanks to Paul)
// solved some little problems with some gcc versions (no new code)
//
// Revision 1.3  1997/04/21 22:37:23  kalle
// Bug in Kconfig gefixed (schrieb sein app-spezifisches File nicht mehr)
// kcolordlg und kapp abgedated (von Martin Jones)
//
// Revision 1.2  1997/04/15 20:01:55  kalle
// Kalles changes for 0.8
//
// Revision 1.1.1.1  1997/04/13 14:42:41  cvsuser
// Source imported
//
// Revision 1.1.1.1  1997/04/09 00:28:06  cvsuser
// Sources imported
//
// Revision 1.10  1997/03/16 22:29:56  kalle
// look for config variables in ~/.kde/config/.appnamerc if the
// environment variable USE_NEW_CONFIG_LOCATION is set
//
// Revision 1.9  1997/03/16 22:21:26  kalle
// patches from Nicolas Hadacek
//
// Revision 1.8  1997/03/16 21:59:58  kalle
// initialize KKeyConfig
//
// Revision 1.7  1997/03/10 20:04:39  kalle
// Merged changes from 0.6.3
//
// Revision 1.6  1997/03/09 17:28:46  kalle
// KTextStream -> QTextStream
//
// Revision 1.5  1997/01/15 20:14:28  kalle
// merged changes from 0.52
//
// Revision 1.4  1996/12/14 13:50:08  kalle
// finding out the state the application config object is in
//
// Revision 1.3  1996/12/07 22:23:26  kalle
// Drag and Drop stuff from Torben added
//
// Revision 1.2  1996/12/07 17:50:49  kalle
// Patches from Nicolas
//
// Revision 1.1  1996/12/01 11:19:55  kalle
// Initial revision
//
//
// KApplication implementation
//
// (C) 1996 Matthias Kalle Dalheimer <mda@stardivision.de>
//
// DND stuff by Torben Weis <weis@stud.uni-frankfurt.de>
// 09.12.96

#include "kapp.moc"

#ifndef _KAPP_H
#include <kapp.h>
#endif

#ifndef _KKEYCONF_H
#include "kkeyconf.h"
#endif

#include <unistd.h>
#include <stdlib.h> // getenv()
#include <X11/Xlib.h>
#include <qobjcoll.h>
#include <qstrlist.h>
#include <qfile.h>
#include <qtstream.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <signal.h>

#include <qwidcoll.h>

KApplication* KApplication::KApp = 0L;
QStrList* KApplication::pSearchPaths;

// prevents children from going zombie
void reaper(int) 
{
  
  wait(0);

  /* The signal handler may not be reinstalled before the call to wait
   * because brain-dead System V systems then would call this signal
   * handler continuously. (See Stevens: Advanced Programming in the
   * Unix Environment, section 10.7. for details.)
   */
  (void)signal(SIGCHLD, reaper); 
}

KApplication::KApplication( int& argc, char** argv ) :
  QApplication( argc, argv )
{
  QString aArgv0 = argv[0];
  int nSlashPos = aArgv0.findRev( '/' );
  if( nSlashPos != -1 )
	aAppName = aArgv0.remove( 0, nSlashPos );
  else
	aAppName = aArgv0;

  parseCommandLine( argc, argv );

  init();
}


KApplication::KApplication( int& argc, char** argv, const QString& rAppName ) :
  QApplication( argc, argv )
{
  aAppName = rAppName;

  parseCommandLine( argc, argv );

  init();
}

void KApplication::init()
{
  (void)signal(SIGCHLD, reaper);
  
  KApp = this;

  pConfigStream = NULL;

  QString aConfigName;
  char* pHome;
  if( (pHome = getenv( "HOME" )) )
	aConfigName = pHome;
  else
	aConfigName = "."; // use current dir if $HOME is not set
  if( getenv( "USE_OLD_CONFIG_LOCATION" ) )
       aConfigName += "/.";
  else  
       aConfigName += "/.kde/config/";
  aConfigName += aAppName;
  aConfigName += "rc";

  pConfigFile = new QFile( aConfigName );
  // Open the application-specific config file. It will be created if
  // it does not exist yet.
  bool bSuccess = pConfigFile->open( IO_ReadWrite ); 
  if( !bSuccess )
	{
	  // try to open at least read-only
	  bSuccess = pConfigFile->open( IO_ReadOnly );
	  if( !bSuccess )
		{
		  // we didn't succeed to open an app-config file
		  pConfig = new KConfig();
		  eConfigState = APPCONFIG_NONE;
		}
	  else
		{
		  // we succeeded to open an app-config file read-only
		  pConfigStream = new QTextStream( pConfigFile );
		  pConfig = new KConfig( pConfigStream );
		  eConfigState = APPCONFIG_READONLY;
		}
	}
  else
	{
	  // we succeeded to open an app-config file read-write
	  pConfigStream = new QTextStream( pConfigFile );
	  pConfig = new KConfig( pConfigStream );
	  eConfigState = APPCONFIG_READWRITE;
	}

  
  // try to read a global application file
  {
    QString aConfigName;
    aConfigName = kdedir();
    aConfigName += "/config/";
    aConfigName += aAppName;
    aConfigName += "rc";
    QFile pConfigFile( aConfigName );
    // try to open read-only
    bSuccess = pConfigFile.open( IO_ReadOnly );
    if( bSuccess )
      {
	// we succeeded to open an app-config file read-only
	{
	  QTextStream  pConfigStream( &pConfigFile );
	  pConfig->parseOneConfigFile( &pConfigStream );
	}
	// parse the application file again to preserve priority
	pConfig->parseOneConfigFile(pConfigStream);
      }
    pConfigFile.close();
  }

  // Drag 'n drop stuff taken from kfm
  display = desktop()->x11Display();
  DndSelection = XInternAtom( display, "DndSelection", False );
  DndProtocol = XInternAtom( display, "DndProtocol", False );    
  DndEnterProtocol = XInternAtom( display, "DndEnterProtocol", False );    
  DndLeaveProtocol = XInternAtom( display, "DndLeaveProtocol", False );    
  DndRootProtocol = XInternAtom( display, "DndRootProtocol", False );    
  lastEnteredDropZone = 0L;
  dropZones.setAutoDelete( FALSE );

  // initialize file search paths
  pSearchPaths = new QStrList();
  buildSearchPaths();

  // initialize KKeyConfig
  initKKeyConfig( getConfig() );  

  KDEChangePalette = XInternAtom( display, "KDEChangePalette", False );
  KDEChangeGeneral = XInternAtom( display, "KDEChangeGeneral", False );
  KDEChangeStyle = XInternAtom( display, "KDEChangeStyle", False);

  readSettings();
  kdisplaySetPalette();
  kdisplaySetStyleAndFont();
}


void KApplication::restoreTopLevelGeometry() const
{
  QWidget* mw = kapp->mainWidget();
  if( !mw )
	return;
  
  pConfig->setGroup( "Geometry" );

  int x = pConfig->readNumEntry( "TopLevelGeometry-x", mw->x() );
  int y = pConfig->readNumEntry( "TopLevelGeometry-y", mw->y() );
  int w = pConfig->readNumEntry( "TopLevelGeometry-w", mw->width() );
  int h = pConfig->readNumEntry( "TopLevelGeometry-h", mw->height() );
  mw->setGeometry( x, y, mw->width(), mw->height() );
  mw->resize( w, h );
}
 

void KApplication::parseCommandLine( int& argc, char** argv )
{
  for( int i = 0; i < argc; i++ )
	if( !strcmp( argv[i], "-caption" ) )
	  aCaption = argv[i+1];
}  


KApplication::~KApplication()
{
  /* If there is a main level widget, save its position and size */
  QWidget* w = kapp->mainWidget();
  if( !w )
	debug( "No main widget when running destructor\n" );
  if( w )
	{
	  pConfig->setGroup( "Geometry" );
	  pConfig->writeEntry( "TopLevelGeometry-x", w->frameGeometry().x() );
	  pConfig->writeEntry( "TopLevelGeometry-y", w->frameGeometry().y() );
	  pConfig->writeEntry( "TopLevelGeometry-w", w->frameGeometry().width() );
	  pConfig->writeEntry( "TopLevelGeometry-h", w->frameGeometry().height() );
	}

  delete kKeys; // must be done before "delete pConfig"

  delete pSearchPaths;

  delete pConfig;
  if( pConfigStream )
	delete pConfigStream;
  pConfigFile->close();
  delete pConfigFile;
}

bool KApplication::x11EventFilter( XEvent *_event )
{
  // You can get root drop events twice.
  // This is to avoid this.
  static int rootDropEventID = -1;
    
  if ( _event->type == ClientMessage )
    {
	  XClientMessageEvent *cme = ( XClientMessageEvent * ) _event;

	  // stuff for reconfiguring
	  if ( cme->message_type == KDEChangeStyle )
		{
		  QString str;
		  
		  getConfig()->setGroup("GUI Style");
		  str = getConfig()->readEntry("Style");
		  if(!str.isNull()) 
			if(str == "Motif")
			  applyGUIStyle(MotifStyle);
			else
			  if(str == "Windows 95")
				applyGUIStyle(WindowsStyle);
		  return TRUE;
		}
 
	  if ( cme->message_type == KDEChangePalette )
		{
		  readSettings();
		  kdisplaySetPalette();
		  
		  return True;
		}
	  if ( cme->message_type == KDEChangeGeneral )
		{
		  readSettings();
		  kdisplaySetStyleAndFont();
		  kdisplaySetPalette();
			  
		  return True;
		}
	  
	  if ( cme->message_type == DndLeaveProtocol )
		{
		  if ( lastEnteredDropZone != 0L )
			lastEnteredDropZone->leave();
	    
		  lastEnteredDropZone = 0L;

		  return TRUE;
		}
	  else if ( cme->message_type != DndProtocol && cme->message_type != DndEnterProtocol &&
				cme->message_type != DndRootProtocol )
	    return FALSE;
	  
	  Window root = DefaultRootWindow(display);
	  
	  unsigned char *Data;
	  unsigned long Size;
	  Atom    ActualType;
	  int     ActualFormat;
	  unsigned long RemainingBytes;
      
	  XGetWindowProperty(display,root,DndSelection,
						 0L,1000000L,
						 FALSE,AnyPropertyType,
						 &ActualType,&ActualFormat,
						 &Size,&RemainingBytes,
						 &Data);

	  QPoint p( (int)cme->data.l[3], (int)cme->data.l[4] );

	  if ( cme->message_type == DndRootProtocol )
		{
		  if ( rootDropEventID == (int)cme->data.l[1] )
			return FALSE;
	    
		  rootDropEventID = (int)cme->data.l[1];

		  if ( rootDropZone != 0L )
			rootDropZone->drop( (char*)Data, Size, (int)cme->data.l[0], p.x(), p.y() );
		  return TRUE;
		}
	
	  KDNDDropZone *dz;
	  KDNDDropZone *result = 0L;
	
	  /*
		for ( dz = dropZones.first(); dz != 0L; dz = dropZones.next() )
		{
		QPoint p2 = dz->getWidget()->mapFromGlobal( p );
		if ( dz->getWidget()->rect().contains( p2 ) )
		result = dz;
		}
	  */

	  QWidget *w = widgetAt( p.x(), p.y(), TRUE );

	  while ( result == 0L && w != 0L )
		{
	      for ( dz = dropZones.first(); dz != 0L; dz = dropZones.next() )
			{
			  if ( dz->getWidget() == w )
				result = dz;
			}
	      
	      if ( result == 0L )
			w = w->parentWidget();
		}

	  // KFM hack. Find not decorated windows ( root icons )
	  if ( result == 0L )
		for ( dz = dropZones.first(); dz != 0L; dz = dropZones.next() )
	      {
			QPoint p2 = dz->getWidget()->mapFromGlobal( p );
			if ( dz->getWidget()->rect().contains( p2 ) )
		      result = dz;
	      }
	  
	  if ( result != 0L )
		{
	      if ( cme->message_type == DndProtocol )
			{
			  result->drop( (char*)Data, Size, (int)cme->data.l[0], p.x(), p.y() );
			}
	      else if ( cme->message_type == DndEnterProtocol )
			{
			  // If we entered another drop zone, tell the drop zone we left about it
			  if ( lastEnteredDropZone != 0L && lastEnteredDropZone != result )
				lastEnteredDropZone->leave();
		  
			  // Notify the drop zone over which the pointer is right now.
			  result->enter( (char*)Data, Size, (int)cme->data.l[0], p.x(), p.y() );
			  lastEnteredDropZone = result;
			}
		}
	  else
		{
		  // Notify the last DropZone that the pointer has left the drop zone.
		  if ( lastEnteredDropZone != 0L )
			lastEnteredDropZone->leave();
		  lastEnteredDropZone = 0L;
		}

	  return TRUE;
    }
    
  return FALSE;
}

void KApplication::applyGUIStyle(GUIStyle newstyle) {
  // get list of toplevels
  QWidgetList *wl = QApplication::topLevelWidgets();
  QWidgetListIt wl_it( *wl );

  // foreach toplevel ...
  while(wl_it.current()) {
    QWidget *w = wl_it.current();

    // set new style
    w->setStyle(newstyle);
    QObjectList *ol = w->queryList("QWidget", 0, 0, TRUE);
    QObjectListIt ol_it( *ol );

    // set style to child widgets
    while ( ol_it.current() ) {
      QWidget *child = (QWidget *)(ol_it.current());
      child->setStyle(newstyle);
      ++ol_it;
    }
    delete ol;
    ++wl_it;
  }

  delete wl;
}

QString KApplication::findFile( const char *file )
{
  QString fullPath;
  QStrListIterator it( *pSearchPaths );

  while ( it.current() )
    {
	  fullPath = it.current();
	  fullPath += '/';
	  fullPath += file;
	  if ( !access( fullPath, 0 ) )
		  return fullPath;
	  ++it;
    }

  fullPath.resize( 0 );

  return fullPath;
}


const char* KApplication::getCaption() const
{
  if( !aCaption.isNull() )
	return aCaption;
  else
	return aAppName;
}


void KApplication::buildSearchPaths()
{
  // add paths from "[KDE Setup]:Path=" config file entry
  getConfig()->setGroup( "KDE Setup" );
  QString kdePathRc = getConfig()->readEntry( "Path" );

  if ( !kdePathRc.isNull() )
    {
      char *start, *end, *workPath = new char [ kdePathRc.length() + 1 ];
	  strcpy( workPath, kdePathRc );
	  start = workPath;
	  while ( start )
		{
	  	  end = strchr( start, ':' );
		  if ( end )
		    *end = '\0';
		  appendSearchPath( start );
		  start = end ? end + 1 : end;
		}
	  delete [] workPath;
    }

  // add paths in the KDEPATH environment variable
  const char *kdePathEnv = getenv( "KDEPATH" );
  if ( kdePathEnv )
    {
	  char *start, *end, *workPath = new char [ strlen( kdePathEnv ) + 1 ];
	  strcpy( workPath, kdePathEnv );
	  start = workPath;
	  while ( start )
		{
	  	  end = strchr( start, ':' );
		  if ( end )
		    *end = '\0';
		  appendSearchPath( start );
		  start = end ? end + 1 : end;
		}
	  delete [] workPath;
    }

 appendSearchPath( kdedir().data() );
}

void KApplication::appendSearchPath( const char *path )
{
  QStrListIterator it( *pSearchPaths );

  // return if this path has already been added
  while ( it.current() )
    {
	  if ( !strcmp( it.current(), path ) )
		  return;
	  ++it;
    }

  pSearchPaths->append( path );
}

void KApplication::readSettings()
{
	// use the global config files
	KConfig config;
	
	QString str;
	
	// This is the default light gray for KDE
	QColor col;
	col.setRgb(214,214,214);


	// Read the color scheme group from config file
	// If unavailable set color scheme to KDE default
	
	config.setGroup( "Color Scheme");
	str = config.readEntry( "InactiveTitleBarColor" );
	if ( !str.isNull() )
		inactiveTitleColor.setNamedColor( str );
	else
		inactiveTitleColor = gray;
		
	str = config.readEntry( "InactiveTitleTextColor" );
	if ( !str.isNull() )
		inactiveTextColor.setNamedColor( str );
	else
		inactiveTextColor = col;
		
	str = config.readEntry( "ActiveTitleBarColor" );
	if ( !str.isNull() )
		activeTitleColor.setNamedColor( str );
	else
		activeTitleColor = black;
		
	str = config.readEntry( "ActiveTitleTextColor" );
	if ( !str.isNull() )
		activeTextColor.setNamedColor( str );
	else
		activeTextColor = white;
		
	str = config.readEntry( "TextColor" );
	if ( !str.isNull() )
		textColor.setNamedColor( str );
	else
		textColor = black;
		
	str = config.readEntry( "BackgroundColor" );
	if ( !str.isNull() )
		backgroundColor.setNamedColor( str );
	else
		backgroundColor = col;
		
	str = config.readEntry( "SelectColor" );
	if ( !str.isNull() )
		selectColor.setNamedColor( str );
	else
		selectColor = black;	
	
	str = config.readEntry( "SelectTextColor" );
	if ( !str.isNull() )
		selectTextColor.setNamedColor( str );
	else
		selectTextColor = white;
		
	str = config.readEntry( "WindowColor" );
	if ( !str.isNull() )
		windowColor.setNamedColor( str );
	else
		windowColor = white;
		
	str = config.readEntry( "WindowTextColor" );
	if ( !str.isNull() )
		windowTextColor.setNamedColor( str );
	else
		windowTextColor = black;
	
	
	//	Read the font specification from config.
	// 	Initialize fonts to default first or it won't work !!
		
	generalFont = QFont("helvetica", 12, QFont::Normal);
	
	config.setGroup( "General Font" );
	str = config.readEntry( "Family" );
	if ( !str.isNull() )
		generalFont.setFamily(str.data());
	
	str = config.readEntry( "Point Size" );
		if ( !str.isNull() )
		generalFont.setPointSize(atoi(str.data()));
	
	str = config.readEntry( "Weight" );
		if ( !str.isNull() )
	generalFont.setWeight(atoi(str.data()));
		
	str = config.readEntry( "Italic" );
		if ( !str.isNull() )
			if ( atoi(str.data()) != 0 )
				generalFont.setItalic(True);
				
	// Finally, read GUI style from config.
	
	config.setGroup( "GUI Style" );
	str = config.readEntry( "Style" );
	if ( !str.isNull() )
	{
		if( str == "Windows 95" )
			applicationStyle=WindowsStyle;
		else
			applicationStyle=MotifStyle;
	} else
			applicationStyle=MotifStyle;	
	
}

void KApplication::kdisplaySetPalette()
{
	// WARNING : QApplication::setPalette() produces inconsistent results.
	// There are 3 problems :-
	// 1) You can't change select colors
	// 2) You need different palettes to apply the same color scheme to
	//		different widgets !!
	// 3) Motif style needs a different palette to Windows style.
	
	if ( applicationStyle==MotifStyle ) {
		QColorGroup disabledgrp( textColor, backgroundColor, 
    							backgroundColor.light(150),
    							backgroundColor.dark(), 
    							backgroundColor.dark(120),
                        	darkGray, windowColor );

    	QColorGroup colgrp( textColor, backgroundColor, 
    							backgroundColor.light(150),
    							backgroundColor.dark(), 
    							backgroundColor.dark(120),
                        	textColor, windowColor );

    	QApplication::setPalette( QPalette(colgrp,disabledgrp,colgrp), TRUE );

	emit kdisplayPaletteChanged();

    } else {
    	QColorGroup disabledgrp( textColor, backgroundColor, 
    							backgroundColor.light(150),
    							backgroundColor.dark(), 
    							backgroundColor.dark(120),
                        	darkGray, windowColor );

    	QColorGroup colgrp( textColor, backgroundColor, 
    							backgroundColor.light(150),
    							backgroundColor.dark(), 
    							backgroundColor.dark(120),
                        	textColor, windowColor );

    	QApplication::setPalette( QPalette(colgrp,disabledgrp,colgrp), TRUE );

	emit kdisplayPaletteChanged();

	}
}

void KApplication::kdisplaySetFont()
{   
    QApplication::setFont( generalFont, TRUE );
    // setFont() works every time for me !

    emit kdisplayFontChanged();    
    resizeAll();
}	


void KApplication::kdisplaySetStyle()
{   
    QApplication::setStyle( applicationStyle );

    emit kdisplayStyleChanged();
    resizeAll();
}	


void KApplication::kdisplaySetStyleAndFont()
{   
    QApplication::setStyle( applicationStyle );
    QApplication::setFont( generalFont, TRUE );
    
    emit kdisplayStyleChanged();
    emit kdisplayFontChanged();
    // 	setStyle() works pretty well but may not change the style of combo
    //	boxes.

	resizeAll();
}	


void KApplication::resizeAll()
{
	// send a resize event to all windows so that they can resize children
	QWidgetList *widgetList = QApplication::topLevelWidgets();
	QWidgetListIt it( *widgetList );

	while ( it.current() )
	{
		it.current()->resize( it.current()->size() );
		++it;
	}
}




void KApplication::invokeHTMLHelp( QString filename, QString topic ) const
{
  if ( fork	() == 0 )	
    {		
	  if( filename.isEmpty() )
		filename = aAppName + '/' + aAppName + ".html";
      QString path = KApplication::kdedir();
      path.append("/doc/HTML/");
      path.append(filename);

	  if( !topic.isEmpty() )
		{
		  path.append( "#" );
		  path.append(topic);
		}

	  /* Since this is a library, we must conside the possibilty that
	   * we are being used by a suid root program. These next two
	   * lines drop all privileges.
	   */
	  setuid( getuid() );
	  setgid( getgid() );
      execlp( "kdehelp", "kdehelp", path.data(), 0 ); 
      exit( 1 );
    }
}


QString KApplication::kdedir()
{
  QString kdedir = getenv("KDEDIR");
  
  if (kdedir.isEmpty())
#ifdef KDEDIR
	kdedir = KDEDIR;
#else
    kdedir = "/usr/local/kde";
#endif

	return kdedir;
}


bool KApplication::getKDEFonts(QStrList *fontlist)
{
  QString fontfilename;

  if(fontlist == NULL)
    return false;

  fontfilename =  getenv("HOME");

  if(fontfilename.isEmpty()){
    return false;
  }
    
  fontfilename = fontfilename + "/.kde/config/kdefonts";

  QFile fontfile(fontfilename);

  if (!fontfile.exists())
    return false;

  if(!fontfile.open(IO_ReadOnly)){
    return false;
  }

  if (!fontfile.isReadable())
    return false;
  
  QTextStream t(&fontfile);


  while ( !t.eof() ) {
    QString s = t.readLine();
    if(!s.isEmpty())
      fontlist->append( s );
  }

  fontfile.close();

  return true;
}
