//
//  KPROCESSCONTROLLER -- A helper class for KProcess
//
//  version 0.2.1, Aug 9th 1997
//
//  (C) Christian Czezatke
//  e9025461@student.tuwien.ac.at
//

#ifndef __KPROCCTRL_H__
#define __KPROCCTRL_H__

#ifndef _MAY_INCLUDE_KPROCESSCONTROLLER_
#error kprocesscontroller.h is a private class and should only be included by "kprocess.cpp"
#endif

#include <qsocknot.h>


/**
  A class for internal use by KProcess only. -- Exactly one instance
  of this class is generated by the first instance of KProcess that is
  created (a pointer to it gets stored in "theKProcessController".
*/
class KProcessController : public QObject
{
  Q_OBJECT

public:
  KProcessController();

  QList<KProcess> *processList;

 public slots:

 void slotDoHousekeeping(int socket);
  void slotNoteSocket(int socket);
private:

  static void theSigCHLDHandler(int signal);
  // handler for sigchld

  int fd[2];
  QSocketNotifier *notifier;
};

extern KProcessController *theKProcessController;

#endif

